import React, { useEffect } from 'react';
import { useDispatch, useSelector, useStore } from 'react-redux';
import { useRouter } from 'next/router';

import { TAB_GENERAL } from '@/modules/adServers/Editor/constants';

import * as selectors from '../redux/selectors';
import {
  createItemAction,
  getItemAction,
  getPlayerTypesOptionsAction,
  setErrorByPropAction,
  setInitialAction,
  setScrollToFieldNameAction,
  updateItemAction,
  validateFields,
} from '../redux/slices';

import { Form, FormContent, FormSection } from '@/modules/@common/Form';
import GeneralTab from './Tabs/GeneralTab/GeneralTab';
import { Button, Stack, Tab, TabContent, Tabs, Typography } from '@/mui/components';

import styles from './Editor.module.scss';

function Editor() {
  const store = useStore();
  const dispatch = useDispatch();
  const router = useRouter();

  const activeTabId = useSelector(selectors.activeTabIdSelector);
  const name = useSelector(selectors.nameSelector);

  const id = parseInt(router.query.id, 10);

  const tabs = [
    {
      title: 'General',
      id: TAB_GENERAL,
      content: GeneralTab,
    },
  ].filter(Boolean);

  const handleSave = () => {
    const state = store.getState();
    const allProps = selectors.fullAccessToStoreFieldsForValidation(state);

    const { validation, errorList } = validateFields(
      selectors
        .schemeSelector(state)
        .filter(({ tabId }) => tabs.some((tab) => tab.id === tabId))
        .map(({ fieldName }) => fieldName),
      allProps,
    );

    if (errorList.length) {
      const errorField = errorList.find((error) => error.tabId === activeTabId) ?? errorList[0];
      dispatch(setScrollToFieldNameAction(errorField.fieldName));
    } else if (id) {
      dispatch(updateItemAction(id));
    } else {
      dispatch(createItemAction());
    }

    dispatch(setErrorByPropAction(validation));
  };

  useEffect(() => {
    dispatch(getPlayerTypesOptionsAction());

    if (id) {
      dispatch(getItemAction({ id }));
    }

    return () => {
      dispatch(setInitialAction());
    };
  }, [id]);

  return (
    <Stack className={styles.Root}>
      <Stack direction="column" fullWidth justifyContent="center" className={styles.Title}>
        <Typography component="div" variant="h6" noWrap>
          {id ? `${name} > Settings` : 'New Ad Server'}
        </Typography>
      </Stack>
      <Stack
        spacing={1}
        fullWidth
        direction="row"
        alignItems="center"
        justifyContent="space-between"
        className={styles.Controls}
      >
        {tabs.length > 1 && (
          <Tabs size="medium" orientation="horizontal" value={activeTabId} className={styles.Tabs}>
            {tabs.map((tab) => (
              <Tab key={tab.id} label={tab.title} value={tab.id} />
            ))}
          </Tabs>
        )}
        <Stack spacing={2} justifyContent="flex-end" alignItems="center" direction="row">
          <Button
            variant="outlined"
            size="small"
            color="primary"
            shape="rounded"
            onClick={() => router.push('/ad-servers')}
          >
            Cancel
          </Button>
          <Button variant="contained" size="small" color="primary" shape="rounded" onClick={handleSave}>
            Save
          </Button>
        </Stack>
      </Stack>
      <Form scrollFieldSelector={selectors.scrollFieldSelector}>
        <FormContent>
          {tabs.map((tab) => {
            const Content = tab.content;

            return (
              <TabContent key={tab.id} component={FormContent} selectedId={activeTabId} id={tab.id}>
                <FormSection>
                  <Content />
                </FormSection>
              </TabContent>
            );
          })}
        </FormContent>
      </Form>
    </Stack>
  );
}

export default Editor;
